﻿Type=StaticCode
Version=4.5
ModulesStructureVersion=1
B4J=true
@EndOfDesignText@
'Static code module
Sub Process_Globals
	Private fx As JFX
End Sub

' Used to Export a SQLite table to an Excel worksheet
Sub ExportTableToXl(Wb As PoiWorkbook,Ws As PoiSheet,TbName As String,formPbar As PbarForm) As Long
	Dim Rs As ResultSet
	Dim iR As Long
	Dim iC As Int
	Dim RsRows As Long
	
	Main.AppLog("ExportTableToXl :: Started")
	'Check that all parameters have values
	If Wb.IsInitialized = False Then
		Main.AppLog("WorkBook Not Initialized - ExportTableToXl")
		fx.Msgbox2(Main.MainForm, "Workbook Not Initialaized", "Error in ExportTableToXl","Ok","","",fx.MSGBOX_ERROR)
		Return 0
	End If
	If Ws.IsInitialized = False Then
		Main.AppLog("WorkSheet Not Initialized - ExportTableToXl")
		fx.Msgbox2(Main.MainForm, "Worksheet Not Itialaized", "Error in ExportTableToXl","Ok","","",fx.MSGBOX_ERROR)
		Return 0
	End If
	TbName = TbName.Trim
	If TbName = "" Then
		Main.AppLog("Table Name is Empty - ExportTableToXl")
		fx.Msgbox2(Main.MainForm, "Table Name is Empty", "Error in ExportTableToXl","Ok","","",fx.MSGBOX_ERROR)
		Return 0
	End If
	
	'Run the sql QUery 
	Rs = AccessSQLite.runquery("SELECT * FROM " & TbName)
 	If Rs.IsInitialized = False Then
		Main.AppLog("SQLite Table " & TbName & " Is Empty")
		fx.Msgbox2(Main.MainForm, "SQLite Table - " & TbName & " Is Empty", "Error in ExportTableToXl","Ok","","",fx.MSGBOX_WARNING)
		Return 0
	End If
	
	'Setup the Title row based on SQLite table column names set style to Blue and bold
	Dim Row As PoiRow = Ws.CreateRow(0)
	Dim TitleStyle As PoiCellStyle
	TitleStyle.Initialize(Wb)
	TitleStyle.ForegroundColor = fx.Colors.Yellow
	Dim Font As PoiFont
	Font.Initialize(Wb)
	Font.Bold = True
	TitleStyle.SetFont(Font)
	'add the column names as headers to the excel file as first row
	For i = 0 To Rs.ColumnCount - 1
		Dim ColName As String = Rs.GetColumnName(i)
		Dim Cell As PoiCell = Row.CreateCellString(i,ColName)
		Cell.CellStyle = TitleStyle
	Next
	
	'get the number of rows in the table
	RsRows = AccessSQLite.SQLiteRows(TbName)
	Main.AppLog("RsRows=" & RsRows)
	If RsRows = 0 Then Return 0	
	
	'loop on the Resultset and add columns data to a new worksheet row
	iR = 1								'Points to the Next Row starting at row 2 (Row start at 0)
	Do While Rs.NextRow
		'Update the ProgressBar
		Dim cPrg As Double = iR / RsRows
		Dim msgP As String = "Export Table " & TbName & " " & Chr(iR) & " - " & Chr(RsRows) & Chr(NumberFormat(iR / RsRows * 100,3,2)) & "%"
		formPbar.setProgress("Table",cPrg,msgP)
		Dim nRow As PoiRow = Ws.CreateRow(iR)
		For iC = 0 To Rs.ColumnCount - 1
			nRow.CreateCellString(iC,Rs.GetString2(iC))
		Next
		iR = iR + 1
	Loop
	'Close the ResultSet
	Rs.Close
	Main.AppLog("ExportTableToXl Complited For Table - " & TbName)
	Return RsRows
End Sub

' Used to Export all tables from lvExp to an Excel WorkBook Each table will be in a new workSheet
Public Sub ExportTablesToXl(fPath As String,Lv As ListView,formPbar As PbarForm)
	Dim i As Int
	Dim XlDir As String
	Dim XlFn As String
	Dim Wb As PoiWorkbook
	Dim TbName As String
	Dim Msg As String
	
	Main.AppLog("ExportTablesToXl :: Started") 
	'Split the Xl Full path to Dir and Filename if empty exit
	If fPath.Trim = "" Then 
		Main.AppLog("File Path Is Empty - ExportTablesToXl")
		fx.Msgbox2(Main.MainForm, "Excel File Path is Empty", "Error in ExportTablesToXl","Ok","","",fx.MSGBOX_ERROR)
		Return
	End If
	i = fPath.LastIndexOf("\")
	XlDir = fPath.SubString2(0,i)
	XlFn = fPath.SubString(i+1)
	
	'Check if xl file exists delete it
	If File.Exists(XlDir,XlFn) = True Then File.Delete(XlDir,XlFn)
	
	'Init the Workbook
	Wb.InitializeNew(True)													'create the new XLSX workbook
	Msg = "ExportTablesToXl Complited"
	'loop on the lv listview and create a new worksheet for each one
	For i = 0 To Lv.Items.Size - 1
		'update the progress bar
		TbName = Lv.Items.Get(i)
		Dim cPrg As Double = (i+1) / Lv.Items.Size 
		Dim MsgP As String  = "Export Tables To Excel "  & Chr(i+1) & " - " & Chr(Lv.Items.size) & Chr(NumberFormat((i+1)/Lv.Items.Size * 100,3,2)) & "%"
		formPbar.setProgress("Tables",cPrg,MsgP)
		Dim Ws As PoiSheet = Wb.AddSheet(TbName,i)    				'Worksheet name will be table name
		Msg = Msg & CRLF & "From " & TbName & " " &  ExportTableToXl(Wb,Ws,TbName,formPbar) & " Records"
	Next
	
	'Close the Progress Bar
	formPbar.closeForm
	
	'Save and Close the Workbook
	Wb.Save(XlDir,XlFn)
	Wb.Close
	Main.AppLog("ExportTablesToXl Complited")
	fx.Msgbox(Main.MainForm,Msg,"ExportTablesToXl") 
End Sub
