﻿Type=StaticCode
Version=4.5
ModulesStructureVersion=1
B4J=true
@EndOfDesignText@
'Static code module
'File: AccessSQLite.Bas
'Purpose: SQLite Db routines

Sub Process_Globals
	Public  DbName As String = ""			'SQLite Db file name
	Public  DbDir As String = File.DirApp  	'Folder for Db - empty is same as application folder
	Public  DbFull As String				'Full path to the DB file
	
	Private fx As JFX
	Public gSQL As SQL
End Sub

Public Sub OpenDb(lDbDir As String,lDbFn As String,CreateIfNotExists As Boolean) As Boolean
	'check that we have valid dir and a valid filename
	If lDbDir = "" Then 
		Main.AppLog("Db Folder is Empty - OpenDb")
		fx.Msgbox2(Main.MainForm, "DataBase Folder is Empty", "Error Opening Database File","Ok","","",fx.MSGBOX_ERROR)
		Return False
	End If
	If lDbFn = "" Then
		Main.AppLog("Db File is empty")
		fx.Msgbox2(Main.MainForm, "Database FileName is Empty", "Error Opening Database File","Ok","","",fx.MSGBOX_ERROR)
		Return False
	End If
	'check that the db file exists
	If File.Exists(lDbDir,lDbFn) = True Then
		Try
			gSQL.InitializeSQLite(lDbDir,lDbFn,CreateIfNotExists)
			If gSQL.IsInitialized = False Then
				Main.AppLog(" Failed to open SQLite Db - " & lDbDir & "\" & lDbFn)
				fx.Msgbox2(Main.MainForm, "Failed to Open SQLite Database", "Error Opening Database File","Ok","","",fx.MSGBOX_ERROR)
				Return False
			Else
				Main.AppLog(" Db Opended")
				Return True
			End If
		Catch
			SQLite_Error("OpenDb")
			Return False
		End Try
	Else
		Return False
	End If
End Sub

'Execute a Query and return a ResultSet 
Public Sub RunQuery(Qry As String) As ResultSet
	Dim Rs As ResultSet
	'Check that Qry is not empty
	If Qry = "" Then Return Rs
	'replace any ' to ''
	Qry = Qry.Replace("'","''")
	Qry = Qry.Replace("~","'")
	Try
		Rs = gSQL.ExecQuery(Qry)
	Catch
		SQLite_Error("RunQuery")
	End Try
	Return Rs	
End Sub

' Retrive the number of records in the input table
Public Sub SQLiteRows(TbName As String) As Long
	Dim Rs As ResultSet
	If TbName = "" Then Return 0
	Try
		Rs = gSQL.ExecQuery("SELECT COUNT(*) FROM " & TbName) 
		If Rs.IsInitialized = True Then
			Return Rs.GetLong2(0)
		Else
			Return 0
		End If
		Rs.Close
	Catch
		SQLite_Error("SQLiteRows")
		Return 0
	End Try
End Sub

' Used to display and log sqlErrors
Public Sub SQLite_Error(ProcName As String)
	Dim Msg As String = LastException.Message
	Main.AppLog("Error in" & ProcName & CRLF & Msg)
	fx.Msgbox2(Main.MainForm,Msg,"Error in " & ProcName,"Ok","","",fx.MSGBOX_ERROR)	
End Sub